/*** SUP3D.C ***/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <graphics.h>
#include <conio.h>

float A, B,                       /* Coordenadas do centro da tela           */
      TAM = 25,                   /* Coeficiente de ampliacao                */
      nu = 50, nv = 50,
      fi = -M_PI/7, teta = -M_PI/7;

/* ------------------------------------------------------------------------- */

int IniciaModoGrafico(void) {

/* Inicializa o modo grafico. Retorna 1 no caso de sucesso ou 0 em caso
   contrario. */

  int gm, gd = DETECT;

  /* registerbgidriver(EGAVGA_driver); */
  initgraph(&gd, &gm, "");
  return (graphresult() == grOk);
}

/* ------------------------------------------------------------------------ */

void ProjetaPonto(float x, float y, float z, float *X, float *Y) {

/* Determina as coordenadas do ponto (x1, y1, z1) no plano de projecao. */

  *X = y*cos(teta) + x*sin(teta);
  *Y = z*cos(fi) + x*cos(teta)*sin(fi) - y*sin(fi)*sin(teta);
}

/* ------------------------------------------------------------------------- */

void DesenhaEixos(int tam, int cor) {

/* Desenha os eixos x, y, z usando tamanho e cor especificados */

  float X0, Y0, X, Y;
  int cor_aux, x_x, x_y, y_x, y_y, z_x, z_y;

  cor_aux = getcolor();
  setcolor(cor);
  ProjetaPonto(0, 0, 0, &X0, &Y0);
  ProjetaPonto(tam, 0, 0, &X, &Y);
  line((int) (A + X0*TAM), (int) (B - Y0*TAM),
       (int) (A + X*TAM), (int) (B - Y*TAM));
  x_x = (int) (A + X*TAM); x_y = (int) (B - Y*TAM);
  ProjetaPonto(0, tam, 0, &X, &Y);
  line((int) (A + X0*TAM), (int) (B - Y0*TAM),
       (int) (A + X*TAM), (int) (B - Y*TAM));
  y_x = (int) (A + X*TAM); y_y = (int) (B - Y*TAM);
  ProjetaPonto(0, 0, tam, &X, &Y);
  line((int) (A + X0*TAM), (int) (B - Y0*TAM),
       (int) (A + X*TAM), (int) (B - Y*TAM));
  z_x = (int) (A + X*TAM); z_y = (int) (B - Y*TAM);

  setcolor(cor_aux);
  outtextxy(x_x, x_y, "x");
  outtextxy(y_x, y_y, "y");
  outtextxy(z_x, z_y, "z");
}

/* ------------------------------------------------------------------------- */

void DesenhaSuperficie(float (*f1) (float, float), float (*f2) (float, float),
			    float (*f3) (float, float), float umin, float umax,
			    float vmin, float vmax) {

  /* Desenha a superficie (f1, f2, f3) usando pequenos quadrilateros */

  float u, v, xp1, yp1, zp1, xp2, yp2, zp2, xp3, yp3, zp3, xp4, yp4, zp4,
	X, Y;
  int xq1, xq2, xq3, xq4, yq1, yq2, yq3, yq4;

  for (u = umin + (umax - umin)/nu; u <= umax + (umax - umin)/(2*nu);
						       u += (umax - umin)/nu)
    for (v = vmin + (vmax - vmin)/nv; v <= vmax + (vmax - vmin)/(2*nv);
						       v += (vmax - vmin)/nv) {

      xp1 = f1(u, v);
      yp1 = f2(u, v);
      zp1 = f3(u, v);

      xp2 = f1(u - (umax - umin)/nu, v);
      yp2 = f2(u - (umax - umin)/nu, v);
      zp2 = f3(u - (umax - umin)/nu, v);

      xp3 = f1(u, v - (vmax - vmin)/nv);
      yp3 = f2(u, v - (vmax - vmin)/nv);
      zp3 = f3(u, v - (vmax - vmin)/nv);

      xp4 = f1(u - (umax - umin)/nu, v - (vmax - vmin)/nv);
      yp4 = f2(u - (umax - umin)/nu, v - (vmax - vmin)/nv);
      zp4 = f3(u - (umax - umin)/nu, v - (vmax - vmin)/nv);

      ProjetaPonto(xp1, yp1, zp1, &X, &Y);
      xq1 = (int) (A + X*TAM); yq1 = (int) (B - Y*TAM);
      ProjetaPonto(xp2, yp2, zp2, &X, &Y);
      xq2 = (int) (A + X*TAM); yq2 = (int) (B - Y*TAM);
      ProjetaPonto(xp3, yp3, zp3, &X, &Y);
      xq3 = (int) (A + X*TAM); yq3 = (int) (B - Y*TAM);
      ProjetaPonto(xp4, yp4, zp4, &X, &Y);
      xq4 = (int) (A + X*TAM); yq4 = (int) (B - Y*TAM);

      line (xq1, yq1, xq2, yq2);
      line (xq4, yq4, xq2, yq2);
      line (xq3, yq3, xq4, yq4);
      line (xq3, yq3, xq1, yq1);
    }
}

/* ------------------------------------------------------------------------- */

float f1(float x, float y) { return x*cos(y); }
float f2(float x, float y) { return x*sin(y); }
float f3(float x, float y) { return y; }

/* ------------------------------------------------------------------------- */

void main(void) {
  IniciaModoGrafico();
  setcolor(4);
  A = getmaxx()/2, B = getmaxy()/2;
  DesenhaSuperficie(f1, f2, f3, -7, 7, -7, 7);
  setcolor(15);
  DesenhaEixos(3, 14);
  getch();
  closegraph();
}

/* ------------------------------------------------------------------------- */

/*** FIM DE "SUP3D.C" ***/